// NetscapeProtocol.cpp : Implementation of WinMain


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f NetscapeProtocolps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "NetscapeProtocol.h"

#include "NetscapeProtocol_i.c"

#include "ScolProtocol.h"

const DWORD dwTimeOut = 5000; // time for EXE to be idle before shutting down
const DWORD dwPause = 1000; // time to wait for threads to finish up

// Passed to CreateThread to monitor the shutdown event
static DWORD WINAPI MonitorProc(void* pv)
{
    CExeModule* p = (CExeModule*)pv;
    p->MonitorShutdown();
    return 0;
}

LONG CExeModule::Unlock()
{
    LONG l = CComModule::Unlock();
    if (l == 0)
    {
        bActivity = true;
        SetEvent(hEventShutdown); // tell monitor that we transitioned to zero
    }
    return l;
}

//Monitors the shutdown event
void CExeModule::MonitorShutdown()
{
    while (1)
    {
        WaitForSingleObject(hEventShutdown, INFINITE);
        DWORD dwWait=0;
        do
        {
            bActivity = false;
            dwWait = WaitForSingleObject(hEventShutdown, dwTimeOut);
        } while (dwWait == WAIT_OBJECT_0);
        // timed out
        if (!bActivity && m_nLockCnt == 0) // if no activity let's really bail
        {
#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
            CoSuspendClassObjects();
            if (!bActivity && m_nLockCnt == 0)
#endif
                break;
        }
    }
    CloseHandle(hEventShutdown);
    PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
}

bool CExeModule::StartMonitor()
{
    hEventShutdown = CreateEvent(NULL, false, false, NULL);
    if (hEventShutdown == NULL)
        return false;
    DWORD dwThreadID;
    HANDLE h = CreateThread(NULL, 0, MonitorProc, this, 0, &dwThreadID);
    return (h != NULL);
}

CExeModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_ScolProtocol, CScolProtocol)
END_OBJECT_MAP()


LPCTSTR FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
    while (p1 != NULL && *p1 != NULL)
    {
        LPCTSTR p = p2;
        while (p != NULL && *p != NULL)
        {
            if (*p1 == *p)
                return CharNext(p1);
            p = CharNext(p);
        }
        p1 = CharNext(p1);
    }
    return NULL;
}

DEFINE_GUID(CLSID_Netscape,0xE67D6A10,0x4438,0x11CE,0x8c,0xe4,0x00,0x20,0xAF,0x18,0xF9,0x05);		// Portions omitted for brevity.

int	RegisterNetscape()
{
// Declarations of variables used.
//(41453471-3850-11CE-8193-0020AF18F905)

	HRESULT hresult;
	IUnknown * punk;
	IDispatch * pdisp;
	OLECHAR FAR* szMember = L"RegisterProtocol";
  OLECHAR FAR* proto=L"scol";
  OLECHAR FAR* handler=L"NetscapeProtocol.ScolProtocol.1";
//  OLECHAR FAR* handler=L"TestNS";
	DISPID dispid;
	VARIANTARG FAR args[2];
  DISPPARAMS dispparamsNoArgs = {args, NULL, 2, 0};
	EXCEPINFO excepinfo;
	UINT nArgErr;

  VariantInit(&args[0]);
  VariantInit(&args[1]);
	args[0].bstrVal = SysAllocString(handler);
	args[1].bstrVal = SysAllocString(proto);

  args[0].vt=VT_BSTR;
  args[1].vt=VT_BSTR;

  // Initialize OLE DLLs.
  hresult = OleInitialize(NULL);
//MessageBox(NULL,"CoCreateInstance","Reg Netscape:",0);
  // OLE function CoCreateInstance starts application using GUID.
  hresult = CoCreateInstance(CLSID_Netscape, NULL, CLSCTX_SERVER, IID_IUnknown, (void FAR* FAR*)&punk);
  if (hresult==S_OK)
  {
//MessageBox(NULL,"QueryInterface","Reg Netscape:",0);
    // Call QueryInterface to see if object supports IDispatch.
    hresult = punk->QueryInterface(IID_IDispatch,(void**) &pdisp);

    if (hresult==S_OK)
    {
//MessageBox(NULL,"GetIDsOfNames","Reg Netscape:",0);
      // Retrieve the dispatch identifier for the SayHello method.
      // Use defaults where possible.
      hresult = pdisp->GetIDsOfNames(
	      IID_NULL,
	      &szMember,
	      1,
	      LOCALE_USER_DEFAULT,
	      &dispid);

      if (hresult==S_OK)
      {
//MessageBox(NULL,"Invoke","Reg Netscape:",0);
        // Invoke the method. Use defaults where possible.
        hresult = pdisp->Invoke(
	        dispid,
	        IID_NULL,
	        LOCALE_SYSTEM_DEFAULT,
	        DISPATCH_METHOD,
	        &dispparamsNoArgs,
	        NULL,
	        NULL,
	        NULL);
      }
    }
  }

//  if (hresult!=S_OK)
//    MessageBox(NULL,"Could not find Netscape to register as a protocol :-(","SCOL installation:",0);

  OleUninitialize();
  return hresult;
}


/////////////////////////////////////////////////////////////////////////////
//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance, 
    HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nShowCmd*/)
{
    lpCmdLine = GetCommandLine(); //this line necessary for _ATL_MIN_CRT

#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
    HRESULT hRes = CoInitializeEx(NULL, COINIT_MULTITHREADED);
#else
    HRESULT hRes = CoInitialize(NULL);
#endif
    _ASSERTE(SUCCEEDED(hRes));
    _Module.Init(ObjectMap, hInstance, &LIBID_NETSCAPEPROTOCOLLib);
    _Module.dwThreadID = GetCurrentThreadId();
    TCHAR szTokens[] = _T("-/");

    int nRet = 0;
    BOOL bRun = TRUE;
    LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);
    while (lpszToken != NULL)
    {
        if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
        {
            _Module.UpdateRegistryFromResource(IDR_NetscapeProtocol, FALSE);
            nRet = _Module.UnregisterServer(TRUE);
            bRun = FALSE;
            break;
        }
        if (lstrcmpi(lpszToken, _T("RegServer"))==0)
        {
			RegisterNetscape();
            _Module.UpdateRegistryFromResource(IDR_NetscapeProtocol, TRUE);
            nRet = _Module.RegisterServer(TRUE);
            bRun = FALSE;
            break;
        }
        lpszToken = FindOneOf(lpszToken, szTokens);
    }

    if (bRun)
    {
        _Module.StartMonitor();
#if _WIN32_WINNT >= 0x0400 & defined(_ATL_FREE_THREADED)
        hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
            REGCLS_MULTIPLEUSE | REGCLS_SUSPENDED);
        _ASSERTE(SUCCEEDED(hRes));
        hRes = CoResumeClassObjects();
#else
        hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER, 
            REGCLS_MULTIPLEUSE);
#endif
        _ASSERTE(SUCCEEDED(hRes));

        MSG msg;
        while (GetMessage(&msg, 0, 0, 0))
            DispatchMessage(&msg);

        _Module.RevokeClassObjects();
        Sleep(dwPause); //wait for any threads to finish
    }

    _Module.Term();
    CoUninitialize();
    return nRet;
}
#include "ScolProtocol.h"
